<?php
$mode = isset($_GET['mode']) ? $_GET['mode']: '';

$config['_metatags'] = isset($_meta) ? (array)$_meta: array();
$config['_metatags']['page'] = isset($page) && $page > 1 ? _t(' - Page %page', array('%page' => (int) $page)) : '';

$langs = array();
if (isset($currentLang) && $currentLang != $config['default_language']) {
    $langs[$currentLang] = $currentLang;
    $config['_metatags'] += array(
        'default_header_title' => $config["default_header_title__{$currentLang}"],
        'default_meta_title' => $config["default_meta_title__{$currentLang}"],
        'default_meta_description' => $config["default_meta_description__{$currentLang}"],
        'default_meta_keywords' => $config["default_meta_keywords__{$currentLang}"],
        'default_meta_robots' => $config["default_meta_robots__{$currentLang}"],
        'sitename' => (isset($config["sitename__{$currentLang}"]) && $config["sitename__{$currentLang}"] != "") ? $config["sitename__{$currentLang}"] : $config['sitename'],
    );
} else {
	$config['default_header_title'] = isset($config['default_header_title']) ? $config['default_header_title'] : ""; 
	$config['default_meta_title'] = isset($config['default_meta_title']) ? $config['default_meta_title'] : ""; 
	$config['default_meta_description'] = isset($config['default_meta_description']) ? $config['default_meta_description'] : ""; 
	$config['default_meta_keywords'] = isset($config['default_meta_keywords']) ? $config['default_meta_keywords'] : ""; 
	$config['default_meta_robots'] = isset($config['default_meta_robots']) ? $config['default_meta_robots'] : ""; 
	$config['sitename'] = isset($config['sitename']) ? $config['sitename'] : ""; 
	
    $config['_metatags'] += array(
        'default_header_title' => $config['default_header_title'],
        'default_meta_title' => $config['default_meta_title'],
        'default_meta_description' => $config['default_meta_description'],
        'default_meta_keywords' => $config['default_meta_keywords'],
        'default_meta_robots' => $config['default_meta_robots'],
        'sitename' => $config['sitename'],
    );
	$langs[$config['default_language']] = $config['default_language'];
}

$metatags = dbRow("SELECT * FROM `metatags` WHERE `controller` = '" . mysqli_real_escape_string($dblink, $thisController) . "' AND `mode` = '" . ($mode != "" ? mysqli_real_escape_string($dblink, $mode) : ($thisController === 'index' ? 'default' : '')) . "' AND `language` IN ('" . implode("','", $langs) . "') ORDER BY FIELD(`language`, '" . implode("','", $langs) . "')", false);
if (!is_array($metatags)) {
    $metatags_core = dbRow("SELECT * FROM `metatags` WHERE `controller` = '" . mysqli_real_escape_string($dbconn, $thisController) . "' AND `mode` = '" . ($mode != "" ? mysqli_real_escape_string($dbconn, $mode) : ($thisController === 'index' ? 'default' : '')) . "' AND `language` = '" . $config['core_language'] . "'", false);
    if (is_array($metatags_core)) {
        unset($metatags_core['record_num']);
        $metatags_core['language'] = $currentLang;
        $metatags = dbInsert('metatags', $metatags_core, true, false, array(), array(), true);
    } else {
        /*
		$metatags = dbInsert('metatags', array(
            'controller' => $thisController,
            'mode' => $mode,
            'header_title' => '{{TITLE}}',
            'meta_title' => '{{SITENAME}}',
            'meta_description' => '{{DESCRIPTION}}',
            'meta_keywords' => '{{KEYWORDS}}',
            'language' => $currentLang != "" ? strtoupper($currentLang) : strtoupper($config['default_language']),
        ), true, false, array(), array(), true);
		*/
    }
}

$langSelect = '';
$langJoin = '';
$langWhere = '';




$config['_metatags']['description'] = htmlentities(truncate(trim($config['_metatags']['description'] . ' ' . $config['_metatags']['meta_description']), 156), ENT_QUOTES, 'UTF-8');
if ($config['_metatags']['description'] == '') {
    $config['_metatags']['description'] = htmlentities($config['_metatags']['default_meta_description'], ENT_QUOTES, 'UTF-8');
}
$config['_metatags']['keywords'] = htmlentities(truncate(trim($config['_metatags']['keywords'] . ' ' . $config['_metatags']['meta_keywords']), 156), ENT_QUOTES, 'UTF-8');
if ($config['_metatags']['keywords'] == '') {
    $config['_metatags']['keywords'] = htmlentities($config['_metatags']['default_meta_keywords'], ENT_QUOTES, 'UTF-8');
}

/* Override certain metatags for specific index modes */
if ($thisController === 'performer') {
	$username = mysqli_real_escape_string($dblink,$_GET['username']); 
	$site = mysqli_real_escape_string($dblink,$_GET['site']); 
	$siteData = dbRow("SELECT record_num,name FROM paysites WHERE slug = '".$site."'");

    $_user = dbRow("SELECT `username`, custom_metadesc, custom_title FROM `performers` WHERE username = '".$username."' AND site = '".$siteData['record_num']."'", true, 300);

	if(isset($_user['custom_metadesc']) && !empty($_user['custom_metadesc'])) { 
		$config['_metatags']['description'] = $_user['custom_metadesc']; 
		$metatags['meta_description'] = $_user['custom_metadesc']; 
	}
    $config['_metatags']['username'] = htmlentities(ucwords($_user['username']), ENT_QUOTES, 'UTF-8');
	$config['_metatags']['site_title'] = htmlentities(ucwords($siteData['name']), ENT_QUOTES, 'UTF-8');
   
}

$replacement = array();
foreach ($config['_metatags'] as $metatag_key => $metatag_value) {
    $replacement['{{' . strtoupper($metatag_key) . '}}'] = $metatag_value;
}

if (is_array($metatags)) {
    foreach ($metatags as &$meta) {
        $meta = strtr($meta, $replacement);
    }
    $title = $metatags['meta_title'];
    $headertitle = $metatags['header_title'];
    $metadescription = $metatags['meta_description'];
    $metakeywords = $metatags['meta_keywords'];
    $metarobots = $metatags['robots'] ? $metatags['robots'] : $config['default_meta_robots'];
} else {
    $title = $config['default_meta_title'];
    $headertitle = $config['default_header_title'];
    $metadescription = $config['default_meta_description'];
    $metakeywords = $config['default_meta_keywords'];
    $metarobots = $config['default_meta_robots'];
}

if($thisController == 'index' && is_array($_GET['tags'])) { 
	$masterTag = trim(mysqli_real_escape_string($dblink,$_GET['tags'][0]));
	$tagData = dbRow("SELECT * FROM niches WHERE name = '$masterTag'");
	if(isset($tagData['metatitle']) && !empty($tagData['metatitle'])) { 
		$title = $tagData['metatitle']; 
	} else { 
		$title = $config['default_meta_title'];
	}
	
	if(isset($tagData['metaheader']) && !empty($tagData['metaheader'])) { 
		$headertitle = $tagData['metaheader']; 
	} else { 
		$headertitle = $config['default_header_title'];
	}
	
	if(isset($tagData['metakw']) && !empty($tagData['metakw'])) { 
		$metakeywords = $tagData['metakw']; 
	} else { 
		$metakeywords = $config['default_meta_keywords'];
	}
	
	if(isset($tagData['metadesc']) && !empty($tagData['metadesc'])) { 
		$metadescription = $tagData['metadesc']; 
	} else { 
		$metadescription = $config['default_meta_description'];
	}
}
